#!/usr/bin/python
# -*- coding: utf-8 -*-

from estlex_law.items import CircuitCaseItem
import scrapy

#Gets all the available data from Riigi Teataja court case search engine.
#Laeb alla kõikide Riigi Teataja otsingulehel leiduvate kohtulahendite PDFid.
class RingkonnakohusSpider(scrapy.Spider):
    Item = CircuitCaseItem
    name = 'ringkonnakohus'
    allowed_domains = ['www.riigiteataja.ee']
    start_urls = []
    url_template = "https://www.riigiteataja.ee/kohtulahendid/otsingutulemus.html?aktiivneTab=KOIK&sort=LahendiKuulutamiseAeg&asc=false&kohtuasjaNumber=&lahendiKpvAlgus=&lahendiKpvLopp=&menetluseKpvAlgus=&menetluseKpvLopp=&kohus={}&kohtunik=&annotatsiooniSisu=&menetluseLiik=&lahendiLiik=&lahendiTekst="
    url_differentiators = [1311, 1318, 1328, 1335] # [riigi, ringkonna, haldus, maa]
    
    custom_settings = {
        'FILES_STORE': "pdf" 
    }
    
    def __init__(self, **kwargs):
        for d in self.url_differentiators:
            self.start_urls.append(self.url_template.format(d))
        super(RingkonnakohusSpider, self).__init__(**kwargs)
    
    def parse(self, response):
        file = response.xpath("//table/tbody/tr/td/a[contains(concat(' ', normalize-space(@title), ' '), ' Fail ')]/@href").extract()
        item = CircuitCaseItem()
        for href in file:
            href = u"https://www.riigiteataja.ee" + href
            item['file_urls'] = [href]
            yield item
            
        next_page = response.css("div.pager>ul>li.next>a").xpath('@href')[0].extract()
        if next_page: 
            url = (u'https://www.riigiteataja.ee/kohtulahendid/otsingutulemus.html' + next_page)
            print url
            yield scrapy.Request(url, self.parse)