# -*- coding: utf-8 -*-
from scrapy.pipelines.files import FilesPipeline, FSFilesStore
from scrapy.utils.misc import md5sum
from estlex_law.spiders.alamkohus import RingkonnakohusSpider
import os.path
import sys
try:
    from cStringIO import StringIO as BytesIO
except ImportError:
    from io import BytesIO

#Works the same with all lower court types.
#Töötab kõikide alamkohtute korral ühtemoodi.
class CircuitCasePipeline(FilesPipeline):        
    #Rewrites file name
    #Modifitseerib faili nime
    def file_downloaded(self, response, request, info):
        path = self.file_path(request, response=response, info=info)
        path = path.rsplit('/',1)[0] + '/' + response.url.rsplit('=',1)[-1]
        buf = BytesIO(response.body)
        self.persist_file(path, buf, info)
        checksum = md5sum(buf)
        return checksum
        
    #Modifies the way data is written
    #Muudab andmete salvestamise viisi
    def persist_file(self, path, buf, info, meta=None, headers=None):
        self.store = self._get_store(RingkonnakohusSpider.custom_settings['FILES_STORE'])
        absolute_path = self.store._get_filesystem_path(path)
        self.store._mkdir(os.path.dirname(absolute_path), info)
        with open(absolute_path + u'.pdf', 'wb') as f:
            f.write(buf.read())